e_atan2.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for e_atan2.c:

Go to the source code of this file.

## Functions

double attribute_hidden | __ieee754_atan2 (double y, double x)

## Variables

static const double | tiny = 1.0e-300
static const double | zero = 0.0
static const double | pi_o_4 = 7.8539816339744827900E-01
static const double | pi_o_2 = 1.5707963267948965580E+00
static const double | pi = 3.1415926535897931160E+00
static const double | pi_lo = 1.2246467991473531772E-16

## Function Documentation

## __ieee754_atan2()

double attribute_hidden __ieee754_atan2 | ( | double | y,
|  | double | x
| ) |  |

Definition at line 50 of file e_atan2.c.

{
double z;
int32_t k,m,hx,hy,ix,iy;
u_int32_t lx,ly;
EXTRACT_WORDS(hx,lx,x);
ix = hx&0x7fffffff;
EXTRACT_WORDS(hy,ly,y);
iy = hy&0x7fffffff;
if(((ix|((lx|-(int32_t)lx)>>31))>0x7ff00000)||
((iy|((ly|-(int32_t)ly)>>31))>0x7ff00000)) /* x or y is NaN */
return x+y;
if(((hx-0x3ff00000)|lx)==0) return atan(y); /* x=1.0 */
m = ((hy>>31)&1)|((hx>>30)&2); /* 2*sign(x)+sign(y) */
/* when y = 0 */
if((iy|ly)==0) {
switch(m) {
case 0:
case 1: return y; /* atan(+-0,+anything)=+-0 */
case 2: return pi+tiny;/* atan(+0,-anything) = pi */
case 3: return -pi-tiny;/* atan(-0,-anything) =-pi */
}
}
/* when x = 0 */
if((ix|lx)==0) return (hy<0)? -pi_o_2-tiny: pi_o_2+tiny;
/* when x is INF */
if(ix==0x7ff00000) {
if(iy==0x7ff00000) {
switch(m) {
case 0: return pi_o_4+tiny;/* atan(+INF,+INF) */
case 1: return -pi_o_4-tiny;/* atan(-INF,+INF) */
case 2: return 3.0*pi_o_4+tiny;/*atan(+INF,-INF)*/
case 3: return -3.0*pi_o_4-tiny;/*atan(-INF,-INF)*/
}
} else {
switch(m) {
case 0: return zero ; /* atan(+...,+INF) */
case 1: return -zero ; /* atan(-...,+INF) */
case 2: return pi+tiny ; /* atan(+...,-INF) */
case 3: return -pi-tiny ; /* atan(-...,-INF) */
}
}
}
/* when y is INF */
if(iy==0x7ff00000) return (hy<0)? -pi_o_2-tiny: pi_o_2+tiny;
/* compute y/x */
k = (iy-ix)>>20;
if(k > 60) z=pi_o_2+0.5*pi_lo; /* |y/x| > 2**60 */
else if(hx<0&&k<-60) z=0.0; /* |y|/x < -2**60 */
else z=atan(fabs(y/x)); /* safe to do y/x */
switch (m) {
case 0: return z ; /* atan(+,+) */
case 1: {
u_int32_t zh;
GET_HIGH_WORD(zh,z);
SET_HIGH_WORD(z,zh ^ 0x80000000);
}
return z ; /* atan(-,+) */
case 2: return pi-(z-pi_lo);/* atan(+,-) */
default: /* case 3 */
return (z-pi_lo)-pi;/* atan(-,-) */
}
}

References atan(), EXTRACT_WORDS, fabs(), GET_HIGH_WORD, k, pi, pi_lo, pi_o_2, pi_o_4, SET_HIGH_WORD, tiny, and zero.

## Variable Documentation

## pi

const double pi = 3.1415926535897931160E+00

static

Definition at line 47 of file e_atan2.c.

Referenced by __ieee754_atan2().

## pi_lo

const double pi_lo = 1.2246467991473531772E-16

static

Definition at line 48 of file e_atan2.c.

Referenced by __ieee754_atan2().

## pi_o_2

const double pi_o_2 = 1.5707963267948965580E+00

static

Definition at line 46 of file e_atan2.c.

Referenced by __ieee754_atan2().

## pi_o_4

const double pi_o_4 = 7.8539816339744827900E-01

static

Definition at line 45 of file e_atan2.c.

Referenced by __ieee754_atan2().

## tiny

const double tiny = 1.0e-300

static

Definition at line 43 of file e_atan2.c.

Referenced by __ieee754_atan2().

## zero

const double zero = 0.0

static

Definition at line 44 of file e_atan2.c.

Referenced by __ieee754_atan2().

pi_o_2
static const double pi_o_2
Definition: e_atan2.c:46
fabs
double fabs(double x)
Definition: s_fabs.c:22
pi_o_4
static const double pi_o_4
Definition: e_atan2.c:45
pi
static const double pi
Definition: e_atan2.c:47
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
EXTRACT_WORDS
#define EXTRACT_WORDS(ix0, ix1, d)
Definition: math_private.h:99
SET_HIGH_WORD
#define SET_HIGH_WORD(d, v)
Definition: math_private.h:137
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
int32_t
signed int int32_t
Definition: SDL_config_windows.h:62
u_int32_t
unsigned int u_int32_t
Definition: math_private.h:31
k
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int int int return Display Window Cursor return Display Window return Display Drawable GC int int unsigned int unsigned int return Display Drawable GC int int _Xconst char int return Display Drawable GC int int unsigned int unsigned int return Display return Display Cursor return Display GC return XModifierKeymap return char Display Window int return Display return Display Atom return Display Window XWindowAttributes return Display Window return Display XEvent Bool(*) XPointer return Display Window Bool unsigned int int int Window Cursor Time return Display Window int return KeySym return Display _Xconst char Bool return Display _Xconst char return XKeyEvent char int KeySym XComposeStatus return Display int int int XVisualInfo return Display Window int int return _Xconst char return Display XEvent return Display Drawable GC XImage int int int int unsigned int unsigned int return Display Window Window Window int int int int unsigned int return Display Window Window int int return Display Window unsigned int unsigned int return Display Window Bool long XEvent return Display GC unsigned long return Display Window int Time return Display Window Window return Display Window unsigned long return Display Window XSizeHints Display Colormap XColor int return char int XTextProperty return XFontStruct _Xconst char int int int int XCharStruct return Display Window return Display Time return Display Colormap return Display Window Window int int unsigned int unsigned int int int return Display Window int return XExtensionInfo Display char XExtensionHooks int XPointer return XExtensionInfo XExtensionInfo Display return Display return Display unsigned long Display GC Display char long Display xReply int Bool return Display Bool return Display int SDL_X11_XESetEventToWireRetType return Display Window Window Window Window unsigned int return Display XShmSegmentInfo return Display Drawable GC XImage int int int int unsigned int unsigned int Boo k)
Definition: SDL_x11sym.h:213
tiny
static const double tiny
Definition: e_atan2.c:43
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
m
const GLfloat * m
Definition: SDL_opengl_glext.h:6092
atan
double atan(double x)
Definition: s_atan.c:71
zero
static const double zero
Definition: e_atan2.c:44
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:109
pi_lo
static const double pi_lo
Definition: e_atan2.c:48